package xyz.tbvns;

import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import java.util.HashMap;

import static xyz.tbvns.GDConstant.EDITOR_LAYER_PROPERTY_ID;

@NoArgsConstructor
@AllArgsConstructor
public class LevelStringBuilder {
    @Getter
    private String levelString = "";
    @Getter @Setter
    private int editorLayer;

    public LevelStringBuilder add(double ... properties) {
        for (double s : properties) {
            levelString += s + ",";
        }
        if (editorLayer != 0) {
            levelString += EDITOR_LAYER_PROPERTY_ID + "," + editorLayer + ",";
        }
        levelString = removeLastChar(levelString);
        levelString += ";";
        return this;
    }

    public LevelStringBuilder add(HashMap<String, String> properties) {
        properties.forEach((k, v) -> {
            levelString += k + "," + v;
        });
        if (editorLayer != 0) {
            levelString += EDITOR_LAYER_PROPERTY_ID + "," + editorLayer + ",";
        }
        levelString = removeLastChar(levelString);
        levelString += ";";
        return this;
    }

    public static String removeLastChar(String s) {
        return (s == null || s.length() == 0)
                ? null
                : (s.substring(0, s.length() - 1));
    }
}
